diff --git a/drivers/usb/device/usb_dc_sam0.c b/drivers/usb/device/usb_dc_sam0.c
index 9171802ab9c8..ba289b28c9a6 100644
--- a/drivers/usb/device/usb_dc_sam0.c
+++ b/drivers/usb/device/usb_dc_sam0.c
@@ -59,10 +59,6 @@ struct usb_sam0_data {
 
 	uint8_t addr;
 	uint32_t out_at;
-
-	/* Memory used as a simple heap for the endpoint buffers */
-	uint32_t ep_buf[USB_NUM_ENDPOINTS * 64 / 4];
-	int brk;
 };
 
 static struct usb_sam0_data usb_sam0_data_0;
@@ -351,9 +347,11 @@ int usb_dc_ep_configure(const struct usb_dc_ep_cfg_data *const cfg)
 	uint8_t ep = cfg->ep_addr & ~USB_EP_DIR_MASK;
 	UsbDeviceEndpoint *endpoint = &regs->DeviceEndpoint[ep];
 	UsbDeviceDescriptor *desc = &data->descriptors[ep];
+	UsbDeviceDescBank *bank = &desc->DeviceDescBank[for_in ? 1 : 0];
 	int type;
 	int size = -1;
 	int i;
+	void *buf;
 
 	/* Map the type to native type */
 	switch (cfg->ep_type) {
@@ -385,22 +383,27 @@ int usb_dc_ep_configure(const struct usb_dc_ep_cfg_data *const cfg)
 		return -EINVAL;
 	}
 
+	/* Release the previous buffer, if any */
+	if (bank->ADDR.reg != 0) {
+		k_free((void *)bank->ADDR.reg);
+	}
+
+	buf = k_malloc(cfg->ep_mps);
+	if (buf == NULL) {
+		return -ENOMEM;
+	}
+
+	bank->PCKSIZE.bit.SIZE = size;
+	bank->ADDR.reg = (uintptr_t)buf;
+
 	if (for_in) {
 		endpoint->EPCFG.bit.EPTYPE1 = type;
-		desc->DeviceDescBank[1].PCKSIZE.bit.SIZE = size;
-		desc->DeviceDescBank[1].ADDR.reg =
-			(uintptr_t)&data->ep_buf[data->brk];
 		endpoint->EPSTATUSCLR.bit.BK1RDY = 1;
 	} else {
 		endpoint->EPCFG.bit.EPTYPE0 = type;
-		desc->DeviceDescBank[0].PCKSIZE.bit.SIZE = size;
-		desc->DeviceDescBank[0].ADDR.reg =
-			(uintptr_t)&data->ep_buf[data->brk];
 		endpoint->EPSTATUSCLR.bit.BK0RDY = 1;
 	}
 
-	data->brk += cfg->ep_mps / sizeof(uint32_t);
-
 	return 0;
 }
 
diff --git a/soc/arm/atmel_sam0/common/Kconfig.defconfig.series b/soc/arm/atmel_sam0/common/Kconfig.defconfig.series
new file mode 100644
index 000000000000..4d62a062ebe4
--- /dev/null
+++ b/soc/arm/atmel_sam0/common/Kconfig.defconfig.series
@@ -0,0 +1,12 @@
+# SPDX-License-Identifier: Apache-2.0
+
+if SOC_FAMILY_SAM0
+
+if USB
+
+config HEAP_MEM_POOL_SIZE
+	default 1024
+
+endif # USB
+
+endif # SOC_FAMILY_SAM0
